unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Menus, ExtCtrls, SaveLVReg, CustSaveIt, Buttons;

type
  TForm1 = class(TForm)
    ListView1: TListView;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    N1: TMenuItem;
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    PageControl1: TPageControl;
    TabSheet2: TTabSheet;
    Memo2: TMemo;
    InsertButton: TButton;
    TabSheet4: TTabSheet;
    Memo4: TMemo;
    TabSheet5: TTabSheet;
    Memo5: TMemo;
    SaveListView1: TSaveListView;
    Panel2: TPanel;
    NewButton: TSpeedButton;
    OpenButton: TSpeedButton;
    SaveButton: TSpeedButton;
    SaveAsButton: TSpeedButton;
    procedure Exit1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure InsertButtonClick(Sender: TObject);
    procedure SaveListView1FileNew(Sender: TObject; var Success: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure SaveListView1AllowSave(Sender: TObject; Allowed: Boolean);
    procedure SaveListView1AllowSaveAs(Sender: TObject; Allowed: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

// *** Begin Ignorable Code ***

procedure TForm1.Exit1Click(Sender: TObject);
begin
  // Exit
  Close;
end;

procedure TForm1.InsertButtonClick(Sender: TObject);
begin
  // TSaveListView: Insert a New Item to the ListView so you can see how
  // the OnAllow Events Work.
  with ListView1.Items.Add do
  begin
    Caption := 'Goodfellow';
    SubItems.Add('John');
    SubItems.Add('34');
    SubItems.Add('435-2456');
    SubItems.Add('Delphi Programmer!');
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.Title := Caption; // Set Application Title to Form's Caption
end;

// *** End Ignorable Code ***

// *** Begin Important Code ***

procedure TForm1.New1Click(Sender: TObject);
begin
  // Make a New Document
  if not SaveListView1.New then
    ShowMessage('Error creating New File');
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  // Open a Document
  SaveListView1.Open;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
  // Save a Document
  SaveListView1.Save;
end;

procedure TForm1.SaveAs1Click(Sender: TObject);
begin
  // SaveAs a Document
  SaveListView1.SaveAs;
end;

procedure TForm1.SaveListView1FileNew(Sender: TObject;
  var Success: Boolean);
begin
  // New Document
  TSaveListView(Sender).ListView.Items.Clear; // Just remove all data from the ListView
end;

procedure TForm1.SaveListView1AllowSave(Sender: TObject; Allowed: Boolean);
begin
  // Enable/Disable Save Menu Items
  Save1.Enabled      := Allowed;
  SaveButton.Enabled := Allowed;
end;

procedure TForm1.SaveListView1AllowSaveAs(Sender: TObject;
  Allowed: Boolean);
begin
  // Enable/Disable SaveAs Buttons & Menu Items
  SaveAs1.Enabled      := Allowed;
  SaveAsButton.Enabled := Allowed;
end;

// *** End Important Code ***

end.
